#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

#define USAGE "usage : ./ViewImage [filename] [width] [height]\n"

int main(int argc, char **argv)
{
  unsigned short *in_image;
  unsigned char *view_image;
  int width,height;
  int i,j,cs;

  if(4 != argc){ 
    fprintf(stderr,USAGE);
    exit(-1);
  }
  width = atoi(argv[2]);
  height = atoi(argv[3]);
  
  printf("File: %s\nwidth=%d\nheight=%d\n",argv[1],width,height);

  in_image = (unsigned short *)calloc((sizeof(short)),width*height);
  view_image = (unsigned char *)calloc((sizeof(char)),width*height);
  read_ushort(in_image, width*height, 0, argv[1]);
  byte_swap(in_image, width*height, 1);

  //   $B$3$3$K8!=PMQ$N=hM}$rDI2C$9$k(B


  /* $BI=<(7O(B */
  /* winproc      12bits -> 8bits$B$XJQ49(B
     reverse      $BGr9uH?E>(B
     reduction    $BI=<(MQ$K2hA|$r=L>.(B $B=L>.N((B1/cs (cs$B$O(B2$B$N$Y$->h?t$N$_(B) 
     InitDisplay  $B%&%$%s%I%&@8@.(B,3$B$DL\$N%Q%i%a!<%?$O@8@.$9$k%&%$%s%I%&$N?t(B($B:GBg(B4$B$^$G(B) 
     DisplayImage $B%&%$%s%I%&$K2hA|$rI=<((B,4$B$D$a$N%Q%i%a!<%?$O;HMQ$9$k%&%$%s%I%&$NHV9f(B
  */
  winproc(in_image, view_image, width*height);
  reverse(view_image, width*height);            
  cs=4;                                         
  reduction(view_image,width,height,cs);        
  InitDisplay(width/cs,height/cs,1);            
  DisplayImage(view_image,width/cs,height/cs,1);
  getchar();
}
